#! d:\perl\bin\perl.exe

use strict;
use Win32::TieRegistry(Delimiter=>"/");

my $server = shift || Win32::NodeName();
my $err;
my %bhos;
my $remote;

print "Extracting BHOs from $server...\n";

# Get Browser Helper Objects
if ($remote = $Registry->{"//$server/LMachine"}) {
	my $ie_bho = "SOFTWARE/Microsoft/Windows/CurrentVersion/Explorer/Browser Helper Objects";
	if (my $bho = $remote->{$ie_bho}) {
		my @keys = $bho->SubKeyNames();
		foreach (@keys) { 
			$bhos{$_} = 1;
		}
	}
	else {
		$err = Win32::FormatMessage Win32::GetLastError();
		print "Error connecting to $ie_bho: $err\n";
	}
}
else {
	$err = Win32::FormatMessage Win32::GetLastError();
	print "Error connecting to Registry: $err\n";
}
undef $remote;

# Find out what each BHO is...
if ($remote = $Registry->{"//$server/LMachine/SOFTWARE/Classes/CLSID/"}) {
	foreach my $key (sort keys %bhos) {
		if (my $conn = $remote->{$key}) {
			my $class = $conn->GetValue("");
			print "Class : $class\n";
			my $module = $conn->{"InprocServer32"}->GetValue("");
			print "Module: $module\n";
		}
		else {
			$err = Win32::FormatMessage Win32::GetLastError();
			print "Error connecting to $key: $err\n";
		}
	}
}
else {
	$err = Win32::FormatMessage Win32::GetLastError();
	print "Error connecting to Registry: $err\n";
}